// $Id: slideshow_creator\040developer.js,v 1.3 2008/02/15 22:30:04 brmassa Exp $
/*******************************************************************************
                     D R U P A L    M O D U L E
********************************************************************************
Module Name        : Slideshow Creator
Original Author    : Bruno Massa http://drupal.org/user/67164
General Links
Project Page       : http://drupal.org/project/slideshow_creator
Support Queue      : http://drupal.org/project/issues/slideshow_creator

*******************************************************************************/

// Preload all images before start the slideshow
function ssc_preload(ss, j) {
  var n = ssc[ss][j];
  if(n) {
    n.image = new Image();
    n.image.src = n.src;
    n.image.onload = function() {ssc_preload(ss, ++j);}
  }
}

// Set the previous slide as the current slide
function ssc_previous(ss) {
  if(!ssc[ss][--ssc[ss].current]) {ssc[ss].current=ssc[ss].total;}
  ssc_update(ss);
}

// Set the next slide as the current slide
function ssc_next(ss) {
  if(!ssc[ss][++ssc[ss].current]) {ssc[ss].current=1;}
  ssc_update(ss);
}

// Update all slide attributes
function ssc_update(ss) {
  if (ssc[ss].rotate > 0) {clearTimeout(ssc[ss].timeout);}
  var obj = ssc[ss][ssc[ss].current];
  if (obj.description) {$("#ssc-description-" + ss).html(obj.description)};
  if (obj.title) {$("#ssc-title-" + ss).html(obj.title);}
  $("#ssc-current-" + ss).html(ssc[ss].current);
  $("#ssc-limage-" + ss).attr("href", obj.link).attr("target", obj.target);
  $("#ssc-ltitle-" + ss).attr("href", obj.link);
  $("#ssc-image-" + ss).attr("src", obj.src).attr("alt", obj.title);
  if (ssc[ss].blend) {$("#ssc-limage-" + ss).fadeIn(ssc[ss].blend * 1000); $("#ssc-limage-" + ss).show();}
  if (ssc[ss].rotate > 0) {ssc[ss].timeout = setTimeout("ssc_next('" + ss + "')", ssc[ss].rotate * 1000);}
}

// initialize all variables and make "previous" and "next" buttons call js functions
function ssc_init() {
  ssc = Drupal.settings.ssc;
  for (ss in ssc) {
    ssc_preload(ss, 1);
    $("#ssc-previous-" + ss).click(function() {ssc_previous(this.id.replace(/ssc-previous-/,"")); return false;});
    $("#ssc-next-" + ss).click(function() {ssc_next(this.id.replace(/ssc-next-/,"")); return false;});
    $("#ssc-image-" + ss).mouseover(function() {
        ss = $(this).attr("id").replace(/ssc-image-/, "");
        if (ssc[ss].rotate > 0) {clearTimeout(ssc[ss].timeout);}
      }).mouseout(function() {
        ss = $(this).attr("id").replace(/ssc-image-/, "");
        if (ssc[ss].rotate > 0) {ssc[ss].timeout = setTimeout("ssc_next('" + ss + "')", ssc[ss].rotate * 1000);}
      });
    if (ssc[ss].blend > ssc[ss].rotate) {ssc[ss].blend = ssc[ss].rotate;}
    if (ssc[ss].rotate > 0) {ssc[ss].timeout = setTimeout("ssc_next('" + ss + "')", ssc[ss].rotate * 1000);}
  }
}

$(function() {ssc_init();})